//  Copyright 2004 Garth Gillespie, All Rights Reserved.
// This C++ code is part of Analog Annelid, the creation of Garth Gillespie,
// And may only be used for educational, non-profit purposes.
// For more information, please visit http://www.garthgillespie.com/annelid/ .

#include"apple.h"
#include"main.h"
#include"glshared.h"
#include"mixer.h"

#include<stdlib.h> // rand(),RAND_MAX

Apple::Apple() // random position, first frame
:xpos(double(H_RESOLUTION)*RANDOM_FLOAT()),ypos(double(V_RESOLUTION)*RANDOM_FLOAT()),frame(1)
{}

void Apple::display(double xmin, double xmax, double ymin, double ymax) const
{
  // display the apple texture in all four quadrants
  display4(xmin,xmax,ymin,ymax,x(),y(),r(),apple_texture);
}

void Apple::collided(Worm &worm, std::list<Collider*> &colliders, std::list<Visual*> &visuals) const
{
  // play a special sound every 1000 points
  if(worm.score()/1000 < (worm.score()+score())/1000) // new increment of 1000
    Mixer_add("score.wav");
  else
    Mixer_add("apple.wav");

  worm.score(score());
  worm.grow(SEGMENTS_per_APPLE);
  colliders.push_back(new Apple()); // make a new apple whenever one is collected
  visuals.push_back(new FlyingNumberVisual(worm.dir(),score(),&font_texture));
}
