//  Copyright 2004 Garth Gillespie, All Rights Reserved.
// This C++ code is part of Analog Annelid, the creation of Garth Gillespie,
// And may only be used for educational, non-profit purposes.
// For more information, please visit http://www.garthgillespie.com/annelid/ .

#include"centeredtexture.h"

#include<GL/gl.h>

void CenteredTexture::display() const
{
  // if no texture is loaded, there's nothing to display
  if(!texName) return;

  // bind the texture and display it as specified
  glBindTexture(GL_TEXTURE_2D,texName);
  glBegin(GL_QUADS);
    // note: vertex coordinates span -1 to 1
    glTexCoord2f(0,0); glVertex3f(-1,-1,0);
    glTexCoord2f(1,0); glVertex3f( 1,-1,0);
    glTexCoord2f(1,1); glVertex3f( 1, 1,0);
    glTexCoord2f(0,1); glVertex3f(-1, 1,0);
  glEnd();
}
