//  Copyright 2004 Garth Gillespie, All Rights Reserved.
// This C++ code is part of Analog Annelid, the creation of Garth Gillespie,
// And may only be used for educational, non-profit purposes.
// For more information, please visit http://www.garthgillespie.com/annelid/ .

// CenteredTexture extends Texture by displaying the image centered on the
// origin.  It holds the same restrictions and specifications as Texture
// except for the functionality of display().
//
// display() maps the texture to (-1,-1),(1,-1),(1,1),(-1,1) .
// Otherwise, it functions as Texture::display().

#ifndef GG_CENTEREDTEXTURE_H
#define GG_CENTEREDTEXTURE_H

#include"texture.h"

class CenteredTexture: private Texture
{
  public:
    CenteredTexture():Texture() {}
    ~CenteredTexture() { unload(); }

    bool load(const char *filename) { return Texture::load(filename); }
    void unload() { Texture::unload(); }

    void display() const;
};

#endif
