//  Copyright 2004 Garth Gillespie, All Rights Reserved.
// This C++ code is part of Analog Annelid, the creation of Garth Gillespie,
// And may only be used for educational, non-profit purposes.
// For more information, please visit http://www.garthgillespie.com/annelid/ .

#include"scrolltexture.h"
#include"targa.h"

#include<GL/gl.h>

bool ScrollTexture::load(const char *filename)
{
  if(!Texture::load(filename))
    return false;

  // set the texture parameters for scrolling
  glBindTexture(GL_TEXTURE_2D,texName);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  return true;
}

void ScrollTexture::display(double xoff, double yoff) const
{
  // if no texture is loaded, there's nothing to display
  if(!texName) return;

  // bind the texture and display it as specified
  glBindTexture(GL_TEXTURE_2D,texName);
  glBegin(GL_QUADS);
    // note: texture coordinates are adjusted by xoff and yoff, OpenGL does the computational work
    glTexCoord2f(xoff  ,yoff  ); glVertex3f(0,0,0);
    glTexCoord2f(xoff+1,yoff  ); glVertex3f(1,0,0);
    glTexCoord2f(xoff+1,yoff+1); glVertex3f(1,1,0);
    glTexCoord2f(xoff  ,yoff+1); glVertex3f(0,1,0);
  glEnd();
}
