//  Copyright 2004 Garth Gillespie, All Rights Reserved.
// This C++ code is part of Analog Annelid, the creation of Garth Gillespie,
// And may only be used for educational, non-profit purposes.
// For more information, please visit http://www.garthgillespie.com/annelid/ .

// ScrollTexture extends Texture to allow scrolling for an image that wraps
// horizontally and vertically.  It holds the same restrictions and
// specifications as Texture except for the functionality of display().
//
// display() takes a horizontal (xoff) and vertical (yoff) offset as
// parameters and scrolls the image that amount (with wrapping).  Otherwise,
// it functions as Texture::display().

#ifndef GG_SCROLLTEXTURE_H
#define GG_SCROLLTEXTURE_H

#include"texture.h"

class ScrollTexture: private Texture
{
  public:
    ScrollTexture():Texture() {}
    ~ScrollTexture() { unload(); }

    bool load(const char *);
    void unload() { Texture::unload(); }

    void display(double xoff, double yoff) const;
};

#endif
