//  Copyright 2004 Garth Gillespie, All Rights Reserved.
// This C++ code is part of Analog Annelid, the creation of Garth Gillespie,
// And may only be used for educational, non-profit purposes.
// For more information, please visit http://www.garthgillespie.com/annelid/ .

#ifndef GG_TARGA_H
#define GG_TARGA_H

// getTGA() returns a newly allocated array of pixel data in the BGR or BGRA format.
// If an error occurs, a null pointer is returned instead.
// If an valid pointer is returned, it is the caller's responsibility to delete/deallocate the array.
// Please note that bpp is BYTES per pixel and not bits per pixel.
unsigned char * getTGA(const char* filename, unsigned int &width, unsigned int &height, unsigned int &bpp);

// convertBGR_RGB() takes an array generated by getTGA() and changes its format.
// The change is either from BGR to RGB or from BGRA to RGBA, as appropriate according to bpp.
// width, height, and bpp should all be the values obtained through getTGA().
// Although convertBGR_RGB() returns a pointer, it is the same one passed to it as data;
// the array pointed to by data is changed directly.
unsigned char * convertBGR_RGB(unsigned char* data, unsigned int width, unsigned int height, unsigned int bpp);

#endif
